<template>
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header display-flex">
                        <div class="col-3 mg-t-5">Appointments</div>
                        <div class="col-9">
                            <button class="btn btn-primary float-right" @click="createAppointment()">
                                Create new
                            </button>
                        </div>
                    </div>

                    <div class="card-body">
                        <div class="alert alert-success" role="alert" v-if="success">
                            {{ success }}
                        </div>
                        <div class="alert alert-danger" role="alert" v-if="error">
                            {{ error }}
                        </div>
                        <table class="table">
                            <thead>
                            <tr>
                                <th>Patient</th>
                                <th>Doctor</th>
                                <th>Date</th>
                                <th>Status</th>
                                <th>Updated</th>
                                <th>Actions</th>
                            </tr>
                            </thead>
                            <tbody>
                            <tr v-for="appointment in appointments" :key="appointment.id">
                                <td>{{ appointment.user }}</td>
                                <td>{{ appointment.doctor }}</td>
                                <td>{{ appointment.date }}</td>
                                <td>{{ appointment.status }}</td>
                                <td>{{ appointment.updated_at }}</td>
                                <td>
                                    <div class="btn-group" role="group">
                                        <button class="btn btn-danger" @click="deleteAppointment(appointment.id)">Delete</button>
                                    </div>
                                </td>
                            </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import axios from 'axios';
import configs from './../../config'

export default {
    data() {
        return {
            appointments: [],
            loading: null,
            error: null,
            success: null
        }
    },
    created() {
        this.fetchAppointments();
    },
    methods: {
        fetchAppointments() {
            this.loading = true;
            axios
                .get(configs.APPOINTMENT_URL + '/taken')
                .then(response => {
                    this.loading = false;
                    this.appointments = response.data;
                })
                .catch(error => {
                    this.loading = false;
                    this.error = error.response.data.message || error.message;
                });
        },

        deleteAppointment(id) {
            axios
                .delete(configs.APPOINTMENT_URL + `/${id}`)
                .then(response => {
                    this.appointments.splice(this.appointments.map(data => data.id).indexOf(id), 1)
                    this.success = response.data
                });
        },

        createAppointment() {
            window.location.href = configs.APPOINTMENT_CREATE_URL;
        }
    }
}
</script>
